/*
 * Implements a global alert service in angular.
 */
angular.module("endroid.kermit.alert", []).factory('alertService',
  ['$rootScope', '$timeout', function($rootScope, $timeout) {
    $rootScope.alerts = [];
    var alertService = {
      add: function(type, msg, timeout) {
        $rootScope.alerts.push({
          type: type,
          msg: msg,
          close: function() {
            return alertService.closeAlert(this);
          }
        });
        var idx = $rootScope.alerts.length - 1;
        if (timeout) {
          $timeout(function() {
            alertService.closeAlertIdx(idx);
          }, timeout);
        }
      },
      closeAlert: function(thisAlert) {
        return this.closeAlertIdx($rootScope.alerts.indexOf(thisAlert));
      },
      closeAlertIdx: function(index) {
        return $rootScope.alerts.splice(index, 1);
      }
    };
    return alertService;
  }]);
