/*
 * Main controllers, etc. for the kermit queue page.
 */
var module = angular.module("endroid", ["ui.bootstrap", "ngAnimate",
                                        "endroid.kermit.alert", "asyncData"]);

function ProfileDisplay($scope, $modal, alertService, asyncData, $http) {
  $scope.keys = initial_keys;
  $scope.generating = false;

  $scope.generate = function() {
    $scope.generating = true;
    asyncData.getData("generatekey").then(function(data) {
      $scope.keys.push(data.success);
      $scope.generating = false;
    }, function(data) {
      $scope.generating = false;
      alertService.add('danger', "Failed to generate a new key: " + data.fail,
                       5000);
    });
  };

  $scope.open = function() {
    var modalInstance = $modal.open({
      templateUrl: 'uploadModel.html',
      controller: ModalInstanceCtrl,
    });

    modalInstance.result.then(function(result) {
      alertService.add('success', "Key uploaded successfully", 5000);
      $scope.keys.push(result);
    }, function(failure) {
      alertService.add('danger', "Failed to upload key: " + failure, 5000);
    });
  };

  $scope.remove = function(idx) {
    $http({
      method: "GET",
      url: "removekey?idx=" + $scope.keys[idx].idx,
    }).then(function(data) {
      $scope.keys.splice(idx, 1);
    }, function(data) {
      alertService.add('danger', "Failed to delete key: " + data.fail, 5000);
    });
  };
};

var ModalInstanceCtrl = function($scope, $modalInstance, $http) {
  $scope.info = {
    privatekey: '',
  };

  $scope.cancel = function() {
    $modalInstance.dismiss("cancelled by you");
  };

  $scope.ok = function() {
    $http({
      method: "POST",
      url: "uploadkey",
      transformRequest: function(obj) {
        var str = [];
        angular.forEach(obj, function(v, k) {
          str.push(encodeURIComponent(k) + "=" + encodeURIComponent(v));
        });
        return str.join("&");
      },
      data: $scope.info,
      headers: {"Content-Type": 'application/x-www-form-urlencoded'}
    }).then(function(data) {
      $modalInstance.close(data.data.success);
    }, function(data) {
      $modalInstance.dismiss(data.data.fail);
    });
  };
};
