
angular.module("filterFocus", []).directive("filterFocus", function($timeout) {
  return {
    link: function(scope, element, attrs) {
      scope.$watch(attrs.filterFocus, function(value) {
        if (value) {
          $timeout(function() {
            element[0].focus();
            scope.$eval(attrs.filterFocus + " = false");
          }, 500);
        }
      });
    }
  };
});

angular.module("asyncData", [])
    .service("asyncData", ['$rootScope', '$q', '$http',
  function($rootScope, $q, $http) {
    var asyncData = function(args) {
      var convertData = args['convertData'] || function(data) { return data; };
      var deferred = $q.defer();

      $http(args).then(function(data) {
        deferred.resolve(convertData(data.data));
        if (!$rootScope.$$phase) $rootScope.$apply();
      }, function(data) {
        deferred.reject();
      });

      return deferred.promise;
    };

    asyncData.getData = function(url, convertData) {
      return asyncData({method: 'GET', url: url, convertData: convertData});
    };

    return asyncData;
  }]);
